> ## Documentation Index
> Fetch the complete documentation index at: https://www.commercengine.io/docs/llms.txt
> Use this file to discover all available pages before exploring further.

# List all customer attributes

> List all customer attributes



## OpenAPI

````yaml https://openapi.commercengine.io/ce-admin.json get /customers/{id}/attributes
openapi: 3.1.0
info:
  title: CE Admin APIs
  version: '1.0'
  summary: Comprehensive admin interface for managing your e-commerce platform
  description: >-
    Complete administrative API suite for Commerce Engine, providing powerful
    tools to manage products, orders, customers, inventory, analytics, and
    system configuration. Designed for administrators and backend integrations
    requiring full platform control.
  license:
    name: All Rights Reserved
    url: https://www.commercengine.io/contact-us
  contact:
    email: support@commercengine.io
    url: https://www.commercengine.io/contact-us
    name: Support
servers:
  - url: https://staging.api.commercengine.io/api/v1/{store_id}/admin
    description: Staging Server
    variables:
      store_id:
        default: store_id
        description: Store ID
  - url: https://prod.api.commercengine.io/api/v1/{store_id}/admin
    description: Prod Server
    variables:
      store_id:
        default: store_id
        description: Store ID
security:
  - Authorization: []
tags:
  - name: Analytics
    description: Analytics
  - name: Catalog
    description: Catalog
  - name: Coupons & promotions
    description: Coupons & promotions
  - name: Customers
    description: Customers
  - name: Filter Options
    description: Filter Options
  - name: Inventories
    description: Inventories
  - name: Marketplace
    description: Marketplace
  - name: Marketplace Catalog
    description: Marketplace Catalog
  - name: Media Gallery
    description: Media Gallery
  - name: Metrics
    description: Metrics
  - name: Orders
    description: Orders
  - name: Payments
    description: Payments
  - name: Payouts
    description: Payouts
  - name: POS
    description: POS
  - name: POSAdmin
    description: Admin endpoints to be used as proxy in pos
  - name: Segments
    description: Segments
  - name: Shipping
    description: Shipping
  - name: SSE
    description: SSE
  - name: Store
    description: Store
  - name: Webhooks
    description: Webhooks
paths:
  /customers/{id}/attributes:
    parameters:
      - name: id
        in: path
        description: customer id
        required: true
        schema:
          type: string
    get:
      tags:
        - Customers
      summary: List all customer attributes
      description: List all customer attributes
      operationId: list-user-attributes
      parameters: []
      responses:
        '200':
          description: OK
          content:
            application/json:
              schema:
                type: object
                properties:
                  message:
                    type: string
                  success:
                    type: boolean
                  content:
                    properties:
                      attributes:
                        type: array
                        items:
                          oneOf:
                            - $ref: '#/components/schemas/StringAttribute'
                            - $ref: '#/components/schemas/IntegerAttribute'
                            - $ref: '#/components/schemas/NumberAttribute'
                            - $ref: '#/components/schemas/BooleanAttribute'
                            - $ref: '#/components/schemas/ListAttribute'
                            - $ref: '#/components/schemas/ObjectAttribute'
                            - $ref: '#/components/schemas/DateTimeAttribute'
                          type: object
                    type: object
components:
  schemas:
    StringAttribute:
      title: StringAttribute
      type: object
      properties:
        id:
          type: string
          readOnly: true
        name:
          type: string
        value:
          type: string
        attribute_type:
          enum:
            - String
        is_readonly:
          type: boolean
          readOnly: true
        last_updated_at:
          type: string
          format: date-time
          readOnly: true
      x-tags:
        - Customers
    IntegerAttribute:
      title: IntegerAttribute
      type: object
      properties:
        id:
          type: string
          readOnly: true
        name:
          type: string
        value:
          type: integer
        attribute_type:
          enum:
            - Integer
        is_readonly:
          type: boolean
          readOnly: true
        last_updated_at:
          type: string
          format: date-time
          readOnly: true
      x-tags:
        - Customers
    NumberAttribute:
      title: NumberAttribute
      type: object
      properties:
        id:
          type: string
          readOnly: true
        name:
          type: string
        value:
          type: number
        attribute_type:
          enum:
            - Number
        is_readonly:
          type: boolean
          readOnly: true
        last_updated_at:
          type: string
          format: date-time
          readOnly: true
      x-tags:
        - Customers
    BooleanAttribute:
      title: BooleanAttribute
      type: object
      properties:
        id:
          type: string
          readOnly: true
        name:
          type: string
        value:
          type: boolean
        attribute_type:
          enum:
            - Boolean
        is_readonly:
          type: boolean
          readOnly: true
        last_updated_at:
          type: string
          format: date-time
          readOnly: true
      x-tags:
        - Customers
    ListAttribute:
      title: ListAttribute
      type: object
      properties:
        id:
          type: string
          readOnly: true
        name:
          type: string
        value:
          type: array
          items:
            type: string
        attribute_type:
          enum:
            - List
        is_readonly:
          type: boolean
          readOnly: true
        last_updated_at:
          type: string
          format: date-time
          readOnly: true
      x-tags:
        - Customers
    ObjectAttribute:
      title: ObjectAttribute
      type: object
      properties:
        id:
          type: string
          readOnly: true
        name:
          type: string
        value:
          type: object
        attribute_type:
          enum:
            - Object
        is_readonly:
          type: boolean
          readOnly: true
        last_updated_at:
          type: string
          format: date-time
          readOnly: true
      x-tags:
        - Customers
    DateTimeAttribute:
      title: DateTimeAttribute
      type: object
      properties:
        id:
          type: string
          readOnly: true
        name:
          type: string
        value:
          type: string
          format: date-time
        attribute_type:
          enum:
            - DateTime
        is_readonly:
          type: boolean
          readOnly: true
        last_updated_at:
          type: string
          format: date-time
          readOnly: true
      x-tags:
        - Customers
  securitySchemes:
    Authorization:
      type: http
      scheme: bearer

````